#include "StdAfx.h"
#include "TinyWebServer.h"
#include <string>
#include <boost/asio.hpp>
#include <boost/bind.hpp>
#include "server.hpp"
#include "CommonFunction.h"

http::server::server *g_server;
CTinyWebServer::CTinyWebServer(void)
{
	g_server = NULL;
	m_pThread = NULL;

}

CTinyWebServer::~CTinyWebServer(void)
{
	if (g_server)
	{
		g_server->stop();

		if (m_pThread != NULL)
		{
			if (WaitForSingleObject(m_pThread->m_hThread, 3000) == WAIT_TIMEOUT)
			{
				// ŸӾƿ   
				m_pThread->SuspendThread();
				m_pThread->ExitInstance();
			}

			m_pThread = NULL;
		}

		delete g_server;
	}
/*
	if (m_pThread)
	{
		TerminateThread(m_pThread->m_hThread, 0);
		if (NULL != g_server)
		{
			g_server->stop();
			delete g_server;
		}

		
		delete m_pThread;
		m_pThread = NULL;
	}
*/
}

bool CTinyWebServer::StartWebServer(void)
{
	bool bReturn = true;

	m_strAddress = Conversion::WideToUtf8(GET_CONFIG()->GetTinyWebServerIP());
	m_strPort = Conversion::WideToUtf8(GET_CONFIG()->GetTinyWebServerPort());
	m_strDocRoot = Conversion::WideToUtf8(GET_CONFIG()->GetTinyWebRoot());
	m_pThread = AfxBeginThread(_TinyWebServerThread, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	if (m_pThread == NULL)
	{
		TRACE(_T("Failed to create _TinyWebServerThread \n"));	
		return false;
	}
	m_pThread->m_bAutoDelete = FALSE;
	m_pThread->ResumeThread();



	return bReturn;

}

UINT CTinyWebServer::_TinyWebServerThread( LPVOID pParam )
{
	CTinyWebServer* pTiny = (CTinyWebServer*) pParam;
	ASSERT(pTiny);
	if (NULL== pTiny)
		return 0;

	if (g_server==NULL)
	{
		g_server = new http::server::server(pTiny->m_strAddress, pTiny->m_strPort, pTiny->m_strDocRoot);
		g_server->run();
	}


	return 0;

}

bool CTinyWebServer::PostDataParsing(const std::string &postdata)
{
	CString strPostData(Conversion::Utf8ToWide(postdata).c_str());

	NTALK_LOG->Debug(L"[NOTE] PostDataParsing %s", strPostData);

	std::vector<CString> vecPostData;
	SplitString(strPostData, _T('&'), vecPostData);
	for(std::vector<CString>::iterator postdataIterator = vecPostData.begin();postdataIterator != vecPostData.end(); ++postdataIterator )
	{
		CString str(*postdataIterator);
		if (str.Find(_T("type=")) > -1)
		{
			str.Replace(_T("type="), _T(""));
			tinyServerMsg.strMsgType.Format(_T("%s"), str);
		}
		else if (str.Find(_T("userid="))> -1)
		{
			str.Replace(_T("userid="), _T(""));
			tinyServerMsg.strUserID.Format(_T("%s"), str);
		}
		else if (str.Find(_T("notedata="))> -1)
		{
			str.Replace(_T("notedata="), _T(""));
			tinyServerMsg.strNoteData.Format(_T("%s"), str);
		}

	}

	GET_MESSENGER_DLG()->PostMessage(WM_TINY_WEBSERVER, (WPARAM)&tinyServerMsg, NULL);

	return true;
}
